## codelite 18.2.0

=== CMakeLists.txt ===
# 3.16 and later is required so we can build CodeLite with PCH
cmake_minimum_required(VERSION 3.16)

# ##############################################################################
#
# CodeLite IDE cmake file Typical usage will be (build in release mode):
#
# Linux / macOS:
# -------------------
# ~~~
# mkdir build
# cd build
# cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release ..
# make -j$(nproc) install
# ~~~
#
# MSYS2
# -------------------
#
# ~~~
# mkdir build-release
# cd build-release
# cmake -G"MinGW Makefiles" -DCMAKE_BUILD_TYPE=Release .. -DWXWIN=C:/msys64/path/to/wx-dir
# make -j$(nproc)
# ~~~
#
# Optional command line arguments:
#
# -DCMAKE_BUILD_TYPE=Release|Debug|DebugFull -DCOPY_WX_LIBS=1|0
# -DPREVENT_WX_ASSERTS=1|0 -DAUTOGEN_REVISION=1|0 -DWITH_PCH=1|0
# -DWITH_NATIVEBOOK=1|0 -DWITH_WXPATH=/path/to/different_wx-config/directory/
# -DMAKE_DEB=1|0 -DENABLE_SFTP=1|0 // When set to 1 Codelite is built with
# SFTP/Remoty support. -DWITH_WX_CONFIG=/path/to/wx-config
#
# Windows / MSYS options:
#
# -DWXWIN=<fullpath>                          //
# https://docs.codelite.org/build/build_wx_widgets/#windows -DWITH_POSIX_LAYOUT
# // When building under Windows, install CodeLite using POSIX layout
#
# ##############################################################################

if(NOT CMAKE_VERSION VERSION_LESS 3.1) # THIS MUST STAY AT THE TOP OF THE FILE
  cmake_policy(VERSION 3.1) # Doing this prevents multiple, very verbose
                            # warnings about policy CMP0053 not being set
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
include(OSXDeps)

# ##############################################################################
# Defaults
# ##############################################################################
project("CodeLite")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(BUILD_TESTING "Build test executables" OFF)

# Set this option to "ON" in order to get CMake standard/expected behavior
set(RETAIN_CACHED_VALUES
    OFF
    CACHE BOOL "Compat option to unset certain cached variables")

if(UNIX AND NOT APPLE)
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    # user did not pass -DCMAKE_INSTALL_PREFIX and this is the first time we are
    # executing cmake, the default is set to /usr/local and we do not want
    # that..
    set(CMAKE_INSTALL_PREFIX
        "/usr"
        CACHE ON "Install prefix" FORCE)
  endif()
endif()

if(MINGW)
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install")
  set(CL_PREFIX "${CMAKE_INSTALL_PREFIX}")
  if(NOT DEFINED ENV{MSYS2_BASE})
    message(
      FATAL_ERROR
        "Set the environment variable MSYS2_BASE to point to the installation of your MSYS2. e.g. export MSYS2_BASE=C:/msys64"
    )
  endif()
  set(MSYS2_BASE $ENV{MSYS2_BASE})
elseif(UNIX AND NOT APPLE)
  if(CL_PREFIX)
    # user provided CL_PREFIX -> use it instead of CMAKE_INSTALL_PREFIX
    set(CMAKE_INSTALL_PREFIX "${CL_PREFIX}")
  else()
    # update CL_PREFIX to CMAKE_INSTALL_PREFIX
    set(CL_PREFIX "${CMAKE_INSTALL_PREFIX}")
  endif()
endif()

message(STATUS "CMAKE_INSTALL_PREFIX is set to ${CMAKE_INSTALL_PREFIX}")
set(CODELITE_VERSION "18.2.0")

# for now, we keep wxCrafter version to be the same as CodeLite version this
# allows for better support
set(WXCRAFTER_VERSION ${CODELITE_VERSION})

# Generate compile_commands.json file for code completion
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CL_SRC_ROOT ${CMAKE_CURRENT_LIST_DIR})

include(UtilsHelper)
find_package(SQLite3)

if(NOT SQLite3_FOUND)
  if(UNIX)
    message(
      FATAL_ERROR
        " **** Could not find sqlite3. Please install libsqlite3-dev package")
  elseif(APPLE)
    message(
      FATAL_ERROR
        " **** Could not find sqlite3. Please install Sqlite3 via brew")
  elseif(MINGW)
    message(
      FATAL_ERROR
        " **** Could not find sqlite3. Please install sqlite3 package: pacman -S mingw-w64-clang-x86_64-sqlite3"
    )
  else()
    message(
      FATAL_ERROR
        " **** Could not find sqlite3. Please install sqlite3 development package"
    )
  endif()
endif()

find_package(BISON REQUIRED)

if(NOT BISON_FOUND)
  if(UNIX)
    message(
      FATAL_ERROR " **** Could not find flex. Please install bison package")
  elseif(APPLE)
    message(FATAL_ERROR " **** Could not find flex. Please install bison")
  elseif(MINGW)
    message(
      FATAL_ERROR
        " **** Could not find flex. Please install bison package: pacman -S bison"
    )
  else()
    message(
      FATAL_ERROR " **** Could not find bison. Please install bison package")
  endif()
endif()

find_package(FLEX REQUIRED)

if(NOT FLEX_FOUND)
  if(UNIX)
    message(
      FATAL_ERROR " **** Could not find flex. Please install flex package")
  elseif(APPLE)
    message(FATAL_ERROR " **** Could not find flex. Please install flex")
  elseif(MINGW)
    message(
      FATAL_ERROR
        " **** Could not find flex. Please install flex package: pacman -S flex"
    )
  else()
    message(
      FATAL_ERROR " **** Could not find flex. Please install flex package")
  endif()
endif()

set(IS_FREEBSD 0)
if(CMAKE_SYSTEM_NAME MATCHES "^.*BSD$|DragonFly")
  set(IS_FREEBSD 1)
  add_compile_definitions(_BSD_SOURCE FREEBSD)
endif()
set(IS_NETBSD 0)
set(BUILD_WXC 0)
set(CL_COPY_WX_LIBS 0)
set(WITH_SFTP 1)

# Create the post_install.cmake script (no append here)
write_file("${CMAKE_BINARY_DIR}/post_install.cmake"
           "message(STATUS \"Running post install script\")")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations"
)# Avoid very multiple warnings spam due to deprecated wx methods
if(UNIX AND NOT APPLE)
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -isystem /usr/include/harfbuzz -isystem /usr/local/include/harfbuzz"
  ) # Needed for fedora 31 so far, but will spread. See
    # https://gitlab.kitware.com/cmake/cmake/issues/19531
endif()

if(UNIX
   AND NOT APPLE
   AND NOT CYGWIN)
  set(CMAKE_EXE_LINKER_FLAGS
      "${CMAKE_EXE_LINKER_FLAGS} -Wl,--disable-new-dtags")
  set(CMAKE_SHARED_LINKER_FLAGS
      "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--disable-new-dtags")
endif()

if(UNIX)
  # Configure CCache if available
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif(CCACHE_FOUND)
endif(UNIX)

if(UNIX)
  set(BUILD_DIRECTORY ${CMAKE_BINARY_DIR})
elseif(MINGW)
  set(BUILD_DIRECTORY ${CMAKE_BINARY_DIR})
else()
  set(BUILD_DIRECTORY $ENV{CD})
endif()

message("-- BUILD_DIRECTORY is set to ${BUILD_DIRECTORY}")

set(OS_NAME "WIN")
if(UNIX)
  execute_process(
    COMMAND uname -s
    OUTPUT_VARIABLE OS_NAME
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()
message("-- OS name ${OS_NAME}")

if(APPLE)
  set(WX_COMPONENTS "std aui propgrid ribbon")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
else(APPLE)
  set(WX_COMPONENTS "std aui propgrid stc ribbon richtext")
endif()

# Appstream metadata
set(METAINFO_FILE
    "${CMAKE_SOURCE_DIR}/Runtime/org.codelite.codelite.metainfo.xml")
install(FILES ${METAINFO_FILE} DESTINATION share/metainfo)

if(WITH_WXPATH)
  set(ENV{PATH} ${WITH_WXPATH}:$ENV{PATH})
endif()
if(NOT RETAIN_CACHED_VALUES)
  unset(WITH_WXPATH CACHE)
endif()

if(WITH_WX_CONFIG)
  set(CL_WX_CONFIG ${WITH_WX_CONFIG})
else(WITH_WX_CONFIG)
  set(CL_WX_CONFIG wx-config)
endif()

if(UNIX AND NOT MINGW)
  execute_process(
    COMMAND which ${CL_WX_CONFIG}
    OUTPUT_VARIABLE WX_TOOL
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT WX_TOOL)
    message(
      FATAL_ERROR
        "\nNo functional wx_config script was found in your PATH.\nIs the wxWidgets development package installed?"
    )
  else()
    # cmake find_package() will try env var WX_CONFIG as wx-config tool path
    # before checking its builtin hardcoded naming conbinations for wx-config
    # tool
    set(ENV{WX_CONFIG} ${WX_TOOL})
    execute_process(
      COMMAND sh ${WX_TOOL} --version
      OUTPUT_VARIABLE WX_VERSION
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    if("${WX_VERSION}" VERSION_LESS "3.1.6")
      message(
        FATAL_ERROR
          "I'm afraid your wxWidgets version is too old.\nBuilding CodeLite requires at least wxWidgets-3.1.6"
      )
    endif()
    if(MINGW)
      execute_process(
        COMMAND sh ${WX_TOOL} --debug=no --rescomp
        OUTPUT_VARIABLE WX_RC_FLAGS
        OUTPUT_STRIP_TRAILING_WHITESPACE)
      string(REGEX REPLACE "windres" "" WX_RC_FLAGS ${WX_RC_FLAGS})
      set(CMAKE_RC_FLAGS "${CMAKE_RC_FLAGS} ${WX_RC_FLAGS}")
      add_compile_definitions(__WXMSW__)
    endif(MINGW)
  endif()
  message("-- wx-config used is: ${WX_TOOL}")
  message("-- wxWidgets version is: ${WX_VERSION}")
  if(NOT APPLE AND NOT MINGW)
    # Is the wx we are using built on gtk2 or 3?
    execute_process(
      COMMAND ${WX_TOOL} --selected_config
      OUTPUT_VARIABLE WX_GTK_VERSION
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    string(SUBSTRING "${WX_GTK_VERSION}" "3" "1" GTK_VERSION)
    message("-- gtk version is: ${GTK_VERSION}")
  endif()
endif()

# ##############################################################################
# Override defaults with user input
# ##############################################################################

set(CL_INSTALL_LIBDIR "lib")

if(NOT MINGW)
  if(NOT CL_PREFIX)
    # If the caller hasn't set his own destination, install to a multi-arch lib
    # dir if applicable
    if(CMAKE_VERSION VERSION_GREATER 2.8.7 AND (UNIX AND NOT APPLE))
      if(CMAKE_VERSION VERSION_GREATER 3.0.0)
        # Prior to this, afaict the GNUInstallDirs module worked whatever the
        # prefix Since, it looks at CMAKE_INSTALL_PREFIX which is /usr/local by
        # default, and refuses to run the multiarch-setting code unless it's
        # /usr/ So, partly to comply with the default documented above, & partly
        # for packaging, explicitly set it to /usr
        set(CMAKE_INSTALL_PREFIX "/usr")
      endif()
      include(GNUInstallDirs) # defines CMAKE_INSTALL_LIBDIR to lib or lib64 or
                              # whatever. Available since cmake 2.8.8
      set(CL_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
    endif()

    set(CL_PREFIX "/usr")
  endif(NOT CL_PREFIX)
endif()

# Define the PLUGINS_DIR variable
if(MINGW)
  # MinGW
  if(WITH_POSIX_LAYOUT)
    set(MINGW_INSTALL_PLUGINS_DIR "${CMAKE_INSTALL_PREFIX}/lib/codelite")
  else()
    set(MINGW_INSTALL_PLUGINS_DIR "${CMAKE_INSTALL_PREFIX}/plugins")
  endif()
  set(MINGW_INSTALL_BIN "${CMAKE_INSTALL_PREFIX}")
endif()

if(APPLE)
  set(PLUGINS_DIR
      ${CMAKE_BINARY_DIR}/codelite.app/Contents/SharedSupport/plugins)
  set(CL_INSTALL_BIN ${CMAKE_BINARY_DIR}/codelite.app/Contents/MacOS)
  set(CL_RESOURCES_DIR ${CMAKE_BINARY_DIR}/codelite.app/Contents/SharedSupport)
elseif(MINGW)
  set(PLUGINS_DIR "${MINGW_INSTALL_PLUGINS_DIR}")
  set(CL_INSTALL_BIN "${MINGW_INSTALL_BIN}")
  set(CL_RESOURCES_DIR "${MINGW_INSTALL_BIN}")
else()
  # /usr/lib/codelite
  set(PLUGINS_DIR "${CL_PREFIX}/${CL_INSTALL_LIBDIR}/codelite")
  # /usr/bin
  set(CL_INSTALL_BIN "${CMAKE_INSTALL_PREFIX}/bin")
  # /usr/share/codelite
  set(CL_RESOURCES_DIR "${CMAKE_INSTALL_PREFIX}/share/codelite")
endif()

message(STATUS "CL_INSTALL_BIN is set to ${CL_INSTALL_BIN}")
message(STATUS "PLUGINS_DIR is set to ${PLUGINS_DIR}")

# Try to link-to or build lldb?
if(UNIX)
  set(WITH_LLDB 1)
else()
  set(WITH_LLDB 0)
endif()
if(ENABLE_LLDB MATCHES 0)
  set(WITH_LLDB 0)
  message("-- Disabling lldb support")
endif()
if(NOT RETAIN_CACHED_VALUES)
  unset(ENABLE_LLDB CACHE)
endif()

set(DISABLE_CXX 0)
if(PHP_BUILD MATCHES 1)
  set(DISABLE_CXX 1)
  add_compile_definitions(PHP_BUILD=1)
else()
  set(DISABLE_CXX 0)
endif()

# ##############################################################################
# Locate libssh
# ##############################################################################
# Enable SFTP support?
if(ENABLE_SFTP MATCHES 0)
  set(WITH_SFTP 0)

=== CMakePlugin/CMakeLists.txt ===
#
# This file is based on QMakePlugin version of the CMakeLists.txt file.
#

# Don't support very old versions

# Create variable for plugin name
set(PLUGIN_NAME "CMakePlugin")

# Define project name
project(${PLUGIN_NAME})

# Find wxWidgets with required components

# wxWidgets include
include("${wxWidgets_USE_FILE}")

# Only with precompiled headers
if(USE_PCH AND NOT MINGW)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif()

# Add all CPP files
file(GLOB SRCS "*.cpp")

# Define the output - shared library
add_library(${PLUGIN_NAME} SHARED ${SRCS})

if(UNIX OR APPLE)
    set_target_properties(${PLUGIN_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(USE_PCH)
    target_precompile_headers(${PLUGIN_NAME} REUSE_FROM PCH)
endif()

# Codelite plugins doesn't use the "lib" prefix.
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
target_link_libraries(${PLUGIN_NAME} ${LINKER_OPTIONS} libcodelite plugin)

cl_install_plugin(${PLUGIN_NAME})

=== CodeLite/CMakeLists.txt ===
# Our project is called 'codelite' this is how it will be called in visual
# studio, and in our makefiles.
project(libcodelite)

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

if(UNIX AND NOT APPLE)
  set(CMAKE_SKIP_BUILD_RPATH TRUE)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
  list(PREPEND CMAKE_INSTALL_RPATH "${PLUGINS_DIR}")
endif(UNIX AND NOT APPLE)

# Flex files
flex_target(
  CxxFlex "${CMAKE_SOURCE_DIR}/CodeLite/Cxx/CxxScanner.l"
  "${CMAKE_CURRENT_BINARY_DIR}/CxxScanner.cpp"
  COMPILE_FLAGS "--noline --yylineno --batch")
flex_target(
  IncludeFinderFlex "${CMAKE_SOURCE_DIR}/CodeLite/Cxx/include_finder.l"
  "${CMAKE_CURRENT_BINARY_DIR}/include_finder.cpp"
  COMPILE_FLAGS "-Pinclf_ --noline --yylineno --batch")
flex_target(
  PhpFlex "${CMAKE_SOURCE_DIR}/CodeLite/PHP/PhpLexer.l"
  "${CMAKE_CURRENT_BINARY_DIR}/PhpLexer.cpp"
  COMPILE_FLAGS "-Pphp --noline --yylineno --batch")

set(FlexSrcs "${FLEX_CxxFlex_OUTPUTS}" "${FLEX_IncludeFinderFlex_OUTPUTS}"
             "${FLEX_PhpFlex_OUTPUTS}")

file(GLOB_RECURSE SRCS "*.cpp" "*.h" "*.hpp")

add_library(libcodelite SHARED ${SRCS} ${FlexSrcs})

# Include paths
target_include_directories(
  libcodelite
  PUBLIC "${CL_SRC_ROOT}/sdk/wxsqlite3/include" "${CL_SRC_ROOT}/CodeLite"
         "${CL_SRC_ROOT}/CodeLite/ssh" "${CL_SRC_ROOT}/PCH"
  PRIVATE "${CL_SRC_ROOT}/submodules/asio/asio/include"
          "${CL_SRC_ROOT}/submodules/websocketpp")

if(WITH_WEBTOOLS)
  target_compile_definitions(libcodelite PUBLIC HAS_ASIO=1)
  message(STATUS "HAS_ASIO set to 1")
else()
  target_compile_definitions(libcodelite PUBLIC HAS_ASIO=0)
  message(STATUS "HAS_ASIO set to 0")
endif()

# Macros
if(WIN32)
  target_compile_definitions(
    libcodelite
    PRIVATE WXMAKINGDLL_CL
    INTERFACE WXUSINGDLL_CL)
  target_compile_definitions(libcodelite PUBLIC WXUSINGDLL_WXSQLITE3)
endif()

if(USE_PCH AND NOT MINGW)
  add_definitions(-include "${CL_PCH_FILE}")
  add_definitions(-Winvalid-pch)
endif()

# Add RPATH
if(NOT MINGW AND WXC_APP)
  string(REPLACE "codelite" "wxcrafter" WXC_LIBS_DIR ${PLUGINS_DIR})
  set(LINKER_OPTIONS -Wl,-rpath,"${WXC_LIBS_DIR}")
  message("-- libcodelite.so is using RPATH set to ${WXC_LIBS_DIR}")
endif()

# Define GTK libraries
if(GTK2_FOUND)
  set(GTK_LIBS "${GTK2_LIBRARIES}")
elseif(GTK3_FOUND)
  set(GTK_LIBS "${GTK3_LIBRARIES}")
else()
  set(GTK_LIBS "")
endif()

set(ADDITIONAL_LIBRARIES "")
if(UNIX)
  if(IS_FREEBSD)
    set(ADDITIONAL_LIBRARIES "-lkvm -lutil")
  elseif(IS_NETBSD)
    set(ADDITIONAL_LIBRARIES "-lutil")
  elseif(UNIX AND NOT APPLE)
    set(ADDITIONAL_LIBRARIES "-ldl -lutil")
  endif()
else(UNIX)
  set(ADDITIONAL_LIBRARIES "-lws2_32")
endif(UNIX)

if(UNIX OR APPLE)
  set_target_properties(libcodelite PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

target_link_libraries(
  libcodelite
  ${LINKER_OPTIONS}
  -L"${CL_LIBPATH}"
  ${SQLite3_LIBRARIES}
  libCxxParser
  wxsqlite3
  ${LIBSSH_LIB}
  ${GTK_LIBS}
  ${ADDITIONAL_LIBRARIES}
  ${LIBUCHARDET_LIB}
  cJSON)

if(MINGW)
  set_target_properties(
    libcodelite
    PROPERTIES PREFIX ""
               OUTPUT_NAME libcodelite
               RUNTIME_OUTPUT_NAME codelite
               ARCHIVE_OUTPUT_NAME codelite)
endif()

if(USE_PCH)
  codelite_add_pch(libcodelite)
endif()

if(NOT MINGW)
  if(APPLE)
    install(TARGETS libcodelite
            DESTINATION ${CMAKE_BINARY_DIR}/codelite.app/Contents/MacOS/)
  else()
    install(TARGETS libcodelite DESTINATION ${PLUGINS_DIR})
  endif()
else()
  install(
    TARGETS libcodelite
    RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX}
    LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
endif()

target_compile_options(libcodelite PUBLIC -Wall)
target_compile_options(libcodelite PUBLIC -Wno-overloaded-virtual)
target_compile_options(libcodelite PUBLIC -Wno-unused-function)
if(IS_CLANG)
  target_compile_options(libcodelite PUBLIC -Wno-unneeded-internal-declaration)
endif()
target_compile_options(libcodelite PUBLIC -Wno-unused-variable)
target_compile_options(libcodelite PUBLIC -Wno-unknown-pragmas)
target_compile_options(libcodelite PUBLIC -Wno-misleading-indentation)
target_compile_options(libcodelite PUBLIC -Wno-unused-label)

=== CodeLiteDiff/CMakeLists.txt ===
# Don't support very old versions

# Create variable for plugin name
set(PLUGIN_NAME "CodeLiteDiff")

# Define project name
project(${PLUGIN_NAME})

# Find wxWidgets with required components

# wxWidgets include
include("${wxWidgets_USE_FILE}")

# Only with precompiled headers
if(USE_PCH AND NOT MINGW)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif()

# Add all CPP files
file(GLOB SRCS "*.cpp")

# Define the output - shared library
add_library(${PLUGIN_NAME} SHARED ${SRCS})

if(UNIX OR APPLE)
    set_target_properties(${PLUGIN_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(USE_PCH)
    target_precompile_headers(${PLUGIN_NAME} REUSE_FROM PCH)
endif()

# Codelite plugins doesn't use the "lib" prefix.
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
target_link_libraries(${PLUGIN_NAME} ${LINKER_OPTIONS} libcodelite plugin)
# Installation destination
cl_install_plugin(${PLUGIN_NAME})

=== ContinuousBuild/CMakeLists.txt ===
# set the plugin name here
set(PLUGIN_NAME "ContinuousBuildPlugin")

# Our project is called 'plugin' this is how it will be called in visual studio, and in our makefiles.
project(${PLUGIN_NAME})

# It was noticed that when using MinGW gcc it is essential that 'core' is mentioned before 'base'.

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

if(USE_PCH)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif(USE_PCH)

file(GLOB SRCS "*.cpp")

# Define the output
add_library(${PLUGIN_NAME} SHARED ${SRCS})

if(UNIX OR APPLE)
    set_target_properties(${PLUGIN_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

set_target_properties(${PLUGIN_NAME} PROPERTIES OUTPUT_NAME "ContinuousBuild")

# Remove the "lib" prefix from the plugin name
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
target_link_libraries(${PLUGIN_NAME} ${LINKER_OPTIONS} libcodelite plugin)
cl_install_plugin(${PLUGIN_NAME})

=== CxxParser/CMakeLists.txt ===
project(CxxParser)

# Bison files
bison_target(
    CppScopeGrammarYacc "${CMAKE_SOURCE_DIR}/CxxParser/cpp_scope_grammar.y"
    "${CMAKE_CURRENT_BINARY_DIR}/cpp_scope_grammar.cpp"
    DEFINES_FILE "${CMAKE_CURRENT_BINARY_DIR}/cpp_lexer.h"
    COMPILE_FLAGS "-p cl_scope_ --no-lines")
bison_target(TypedefGrammarYacc "${CMAKE_SOURCE_DIR}/CxxParser/typedef_grammar.y"
             "${CMAKE_CURRENT_BINARY_DIR}/typedef_parser.cpp" COMPILE_FLAGS "-p cl_typedef_ --no-lines")
bison_target(CppVariablesGrammarYacc "${CMAKE_SOURCE_DIR}/CxxParser/cpp_variables_grammar.y"
             "${CMAKE_CURRENT_BINARY_DIR}/var_parser.cpp" COMPILE_FLAGS "-p cl_var_ --no-lines")
bison_target(ExprGrammarYacc "${CMAKE_SOURCE_DIR}/CxxParser/expr_grammar.y"
             "${CMAKE_CURRENT_BINARY_DIR}/cpp_expr_parser.cpp" COMPILE_FLAGS "-p cl_expr_ --no-lines")
bison_target(CppFuncParserYacc "${CMAKE_SOURCE_DIR}/CxxParser/cpp_func_parser.y"
             "${CMAKE_CURRENT_BINARY_DIR}/cpp_func_parser.cpp" COMPILE_FLAGS "-p cl_func_ --no-lines")

set(BisonSrcs
    "${BISON_CppScopeGrammarYacc_OUTPUTS}" "${BISON_TypedefGrammarYacc_OUTPUTS}"
    "${BISON_CppVariablesGrammarYacc_OUTPUTS}" "${BISON_ExprGrammarYacc_OUTPUTS}" "${BISON_CppFuncParserYacc_OUTPUTS}")

# Flex files
flex_target(CppFlex "${CMAKE_SOURCE_DIR}/CxxParser/cpp.l" "${CMAKE_CURRENT_BINARY_DIR}/cpp.cpp"
            COMPILE_FLAGS "-Pcl_scope_ --noline --yylineno --batch")
# Increase YY_BUF_SIZE from 16384 to 16384*5
set_source_files_properties("${FLEX_CppFlex_OUTPUTS}" PROPERTIES COMPILE_DEFINITIONS "YY_BUF_SIZE=(16384*5)")
flex_target(ExprLexerFlex "${CMAKE_SOURCE_DIR}/CxxParser/expr_lexer.l" "${CMAKE_CURRENT_BINARY_DIR}/expr_lexer.cpp"
            COMPILE_FLAGS "-Pcl_expr_ --noline --yylineno --batch")
# Increase YY_BUF_SIZE from 16384 to 16384*5
set_source_files_properties("${FLEX_ExprLexerFlex_OUTPUTS}" PROPERTIES COMPILE_DEFINITIONS "YY_BUF_SIZE=(16384*5)")

add_flex_bison_dependency(CppFlex CppScopeGrammarYacc)
add_flex_bison_dependency(ExprLexerFlex CppScopeGrammarYacc)

set(FlexSrcs "${FLEX_CppFlex_OUTPUTS}" "${FLEX_ExprLexerFlex_OUTPUTS}")

# Define the outputs
add_library(
    libCxxParser STATIC
    cl_typedef.h
    code_completion_api.h
    expression_result.cpp
    expression_result.h
    function.cpp
    function.h
    variable.cpp
    variable.h
    ${FlexSrcs}
    ${BisonSrcs})

if(UNIX OR APPLE)
    set_target_properties(libCxxParser PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

# Include paths
target_include_directories(
    libCxxParser
    PUBLIC "${CL_SRC_ROOT}/CxxParser"
    PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")
if(WIN32)
    target_compile_definitions(libCxxParser PRIVATE WXMAKINGDLL_CL)
endif()

# "testing" application
add_executable(CxxParser main.cpp)

target_link_libraries(CxxParser PRIVATE libCxxParser)

=== CxxParserTests/CMakeLists.txt ===
project(CxxLocalVariables)

# It was noticed that when using MinGW gcc it is essential that 'core' is mentioned before 'base'.

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

if(USE_PCH AND NOT MINGW)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif()

file(GLOB SRCS "*.cpp")

# Define the output
add_executable(CxxLocalVariables ${SRCS})

if(USE_PCH)
    target_precompile_headers(${PLUGIN_NAME} REUSE_FROM PCH)
endif()

# Remove the "lib" prefix from the plugin name
target_link_libraries(CxxLocalVariables ${LINKER_OPTIONS} libcodelite plugin wxsqlite3)
add_compile_definitions(CXX_TEST_DIR=\"${CL_SRC_ROOT}/CxxParserTests/Test/\")
cl_install_executable(CxxLocalVariables)

add_test(NAME "CxxParserTests" COMMAND CxxLocalVariables)

=== DatabaseExplorer/CMakeLists.txt ===
# set the plugin name here
set(PLUGIN_NAME "DatabaseExplorer")

# Our project is called 'plugin' this is how it will be called in visual studio, and in our makefiles.
project(${PLUGIN_NAME})

# It was noticed that when using MinGW gcc it is essential that 'core' is mentioned before 'base'.

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

if(WITH_MYSQL)
    find_library(LIBMYSQLCLIENT NAMES libmysqlclient.so)
    if(${LIBMYSQLCLIENT} STREQUAL "LIBMYSQLCLIENT-NOTFOUND")
        message(FATAL_ERROR "-- Could not locate libmysqlclient.so")
    else(${LIBMYSQLCLIENT} STREQUAL "LIBMYSQLCLIENT-NOTFOUND")
        message("-- LIBMYSQLCLIENT is set to ${LIBMYSQLCLIENT}")
    endif(${LIBMYSQLCLIENT} STREQUAL "LIBMYSQLCLIENT-NOTFOUND")
    add_compile_definitions(DBL_USE_MYSQL=1)

    if(MINGW)
        install(FILES "${MSYS2_BASE}/clang64/bin/libmariadb.dll" DESTINATION "${CMAKE_INSTALL_PREFIX}")
        msys_list_deps(${MSYS2_BASE}/clang64/bin/libmariadb.dll LIBMARIA_DEPS)
        foreach(DEP ${LIBMARIA_DEPS})
            install(FILES "${DEP}" DESTINATION "${CMAKE_INSTALL_PREFIX}")
        endforeach()
    endif()
    unset(WITH_MYSQL CACHE)
endif(WITH_MYSQL)

if(WITH_POSTGRES)
    find_package(PostgreSQL REQUIRED)

    add_compile_definitions(DBL_USE_POSTGRES=1)

    if(MINGW)
        install(FILES "${MSYS2_BASE}/clang64/bin/libpq.dll" DESTINATION "${CMAKE_INSTALL_PREFIX}")
        msys_list_deps(${MSYS2_BASE}/clang64/bin/libpq.dll LIBPOSTGRES_DEPS)
        foreach(DEP ${LIBPOSTGRES_DEPS})
            install(FILES "${DEP}" DESTINATION "${CMAKE_INSTALL_PREFIX}")
        endforeach()
    endif()
endif()

# On UNIX we require GTK
if(UNIX AND NOT APPLE)

    if(GTK_VERSION EQUAL 3)
        set(OLD_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}) # Cache the current value
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
        find_package(GTK3)
        set(CMAKE_MODULE_PATH ${OLD_CMAKE_MODULE_PATH}) # Reset, else the official path isn't used again :/
        if(GTK3_FOUND)
            include_directories(${GTK3_INCLUDE_DIRS})
        else(GTK3_FOUND)
            message(FATAL_ERROR "Could not locate GTK.")
        endif(GTK3_FOUND)
    else()
        find_package(GTK2)
        if(GTK2_FOUND)
            include_directories(${GTK2_INCLUDE_DIRS})
        else(GTK2_FOUND)
            message(FATAL_ERROR "Could not locate GTK.")
        endif(GTK2_FOUND)
    endif()

endif(UNIX AND NOT APPLE)

if(USE_PCH AND NOT MINGW)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif()

# Include paths
include_directories("${CL_SRC_ROOT}/sdk/databaselayer/include")

add_compile_definitions(DBL_USE_SQLITE)

file(GLOB SRCS "*.cpp")

# Define the output
add_library(${PLUGIN_NAME} SHARED ${SRCS})

if(UNIX OR APPLE)
    set_target_properties(${PLUGIN_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(USE_PCH)
    target_precompile_headers(${PLUGIN_NAME} REUSE_FROM PCH)
endif()

# Remove the "lib" prefix from the plugin name
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")

if(GTK3_FOUND)
    set(GTK_LIBS ${GTK3_LIBRARIES})
else()
    set(GTK_LIBS ${GTK2_LIBRARIES})
endif()

target_link_libraries(
    ${PLUGIN_NAME}
    ${LINKER_OPTIONS}
    ${GTK_LIBS}
    libcodelite
    plugin
    wxshapeframework
    databaselayersqlite)
cl_install_plugin(${PLUGIN_NAME})

=== DebugAdapterClient/CMakeLists.txt ===
# lldb requires C++11
set(PLUGIN_NAME "DebugAdapterClient")
project(DebugAdapterClient)

add_subdirectory("${CL_SRC_ROOT}/submodules/wxdap/dap" ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

# By default, use the sources under the current folder
file(GLOB PLUGIN_SRCS "*.cpp")

# Define the output - shared library
add_library(${PLUGIN_NAME} SHARED ${PLUGIN_SRCS})

# Codelite plugins doesn't use the "lib" prefix.
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
target_link_libraries(${PLUGIN_NAME} ${LINKER_OPTIONS} ${LIBLLDB} libcodelite plugin dapcxx)
target_include_directories(${PLUGIN_NAME} PRIVATE "${CL_SRC_ROOT}/submodules/wxdap")
# Installation destination
cl_install_plugin(${PLUGIN_NAME})
codelite_install_library_target(dapcxx)

=== Debugger/CMakeLists.txt ===
# set the plugin name here
set(PLUGIN_NAME "DebuggerGDB")

# Our project is called 'plugin' this is how it will be called in visual studio, and in our makefiles.
project(${PLUGIN_NAME})

# It was noticed that when using MinGW gcc it is essential that 'core' is mentioned before 'base'.

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

if(USE_PCH AND NOT MINGW)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif()

file(GLOB SRCS "*.cpp")

# Define the output
add_library(${PLUGIN_NAME} SHARED ${SRCS})

if(UNIX OR APPLE)
    set_target_properties(${PLUGIN_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(USE_PCH)
    target_precompile_headers(${PLUGIN_NAME} REUSE_FROM PCH)
endif()

# Remove the "lib" prefix from the plugin name
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
target_link_libraries(${PLUGIN_NAME} ${LINKER_OPTIONS} libcodelite plugin libgdbparser)

if(MINGW AND WITH_POSIX_LAYOUT)
    install(
        TARGETS DebuggerGDB
        RUNTIME DESTINATION ${PLUGINS_DIR}/debuggers
        LIBRARY DESTINATION ${PLUGINS_DIR}/debuggers
        ARCHIVE DESTINATION ${PLUGINS_DIR}/debuggers)
else()
    cl_install_debugger(${PLUGIN_NAME})
endif()

=== EOSWiki/CMakeLists.txt ===
# set the plugin name here
set(PLUGIN_NAME "EOSWiki")

# Our project is called 'plugin' this is how it will be called in visual studio, and in our makefiles.
project(${PLUGIN_NAME})

# It was noticed that when using MinGW gcc it is essential that 'core' is mentioned before 'base'.

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

if(USE_PCH AND NOT MINGW)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif()

file(GLOB SRCS "*.cpp")

# Define the output
add_library(${PLUGIN_NAME} SHARED ${SRCS})

if(UNIX OR APPLE)
    set_target_properties(${PLUGIN_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(USE_PCH)
    target_precompile_headers(${PLUGIN_NAME} REUSE_FROM PCH)
endif()

# Remove the "lib" prefix from the plugin name
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
target_link_libraries(${PLUGIN_NAME} ${LINKER_OPTIONS} libcodelite plugin)

# Use CodeLite's macro: CL_INSTALL_PLUGIN which handles both OSX and Linux installation
cl_install_plugin(${PLUGIN_NAME})

# Install the resources
cl_install_file_shared(${CL_SRC_ROOT}/EOSWiki/resources/eoswiki.zip)

=== EditorConfigPlugin/CMakeLists.txt ===
# set the plugin name here
set(PLUGIN_NAME "EditorConfigPlugin")

# Our project is called 'plugin' this is how it will be called in visual studio, and in our makefiles.
project(${PLUGIN_NAME})

# It was noticed that when using MinGW gcc it is essential that 'core' is mentioned before 'base'.

# wxWidgets include (this will do all the magic to configure everything)
include("${wxWidgets_USE_FILE}")

if(USE_PCH AND NOT MINGW)
    add_definitions(-include "${CL_PCH_FILE}")
    add_definitions(-Winvalid-pch)
endif()

file(GLOB SRCS "*.cpp")

# Define the output
add_library(${PLUGIN_NAME} SHARED ${SRCS})

if(UNIX OR APPLE)
    set_target_properties(${PLUGIN_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(USE_PCH)
    target_precompile_headers(${PLUGIN_NAME} REUSE_FROM PCH)
endif()

# Remove the "lib" prefix from the plugin name
set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
target_link_libraries(${PLUGIN_NAME} ${LINKER_OPTIONS} libcodelite plugin)

# Use CodeLite's macro: CL_INSTALL_PLUGIN which handles both OSX and Linux installation
cl_install_plugin(${PLUGIN_NAME})

=== debian/changelog ===
codelite (18.2.0-2unofficial.trixie) stable; urgency=low

  * Add libpcre2-32-0 to 'Depends'.
  * See https://github.com/eranif/codelite/issues/3762

 -- David Hart <david@codelite.co.uk>  Wed, 05 Nov 2025 10:41:23 +0000

codelite (18.2.0-1unofficial.trixie) stable; urgency=low

  * Update for the 18.2.0 release

 -- David Hart <david@codelite.co.uk>  Wed, 05 Nov 2025 10:41:23 +0000

codelite (18.1-1unofficial.bookworm) stable; urgency=low

  * Update for the 18.1 release

 -- David Hart <david@codelite.co.uk>  Sat, 18 Jan 2025 10:36:59 +0000

=== debian/control ===
Source: codelite
Section: devel
Priority: optional
Maintainer: David Hart <david@codelite.co.uk>
Build-Depends: debhelper (>= 7.0.50~),  cmake, libclang-dev (>=3.4), liblldb-dev (>=3.9) | liblldb-3.9-dev | liblldb-4.0-dev, libssh-dev | libssh-gcrypt-dev, libhunspell-dev, libsqlite3-dev
Standards-Version: 3.9.1
Homepage: http://www.codelite.org


Package: codelite
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcre2-32-0
Recommends: gdb, lldb (>=3.4), gnome-terminal | konsole | lxterminal | mate-terminal | qterminal | xfce4-terminal, xterm, nodejs, clang-tools, clang-format, libncurses
Conflicts: codelite, codelite-plugins, wxcrafter
Description: cross-platform C/C++ RAD
 Codelite is a powerful open-source, cross-platform code editor and RAD.
 It uses a sophisticated yet intuitive interface, which allows the user
 easily to create and build complex projects.
 A particular feature is its excellent code completion.


Package: codelite-dbg
Architecture: any
Depends: codelite (= ${binary:Version})
Recommends: gdb
Description: Debug symbols for CodeLite
 Codelite is a powerful open-source, cross-platform code editor and RAD.
 It uses a sophisticated yet intuitive interface, which allows the user
 easily to create and build complex projects.
 A particular feature is its excellent code completion.
